//
// Frdric Boulanger
// Suplec - Dpartement Informatique
// 3 rue Joliot-Curie
// 91192 Gif-sur-Yvette cedex, France
//
// frederic.boulanger@supelec.fr
//
/**
 * Forme d'onde carre.
 */
class FormeCarre extends FormeOnde {
  /**
   * Cre une forme d'onde carre de frquence fondamentale
   * <code>f0</code>  la frquence d'chantillonnage <code>fe</code>.
   */
  public FormeCarre(double f0, double fe) {
    super(f0, fe);
  }

  /**
   * Calcule un chantillon de la sinusode.
   */
  public double echantillon(int i) {
    double periode = 1 / f0_;
    // On se ramne dans la priode [0, periode[
    double t = Math.IEEEremainder(i/fe_, periode);
    // IEEEremainder nous ramne dans [-periode/2, periode/2[,
    // on ajoute donc periode au rsultat si t est ngatif.
    if (t < 0) {
      t += periode;
    }
    // Si on est avant la demi-priode, le signal vaut 1,
    // sinon, il vaut -1
    if (t < periode/2) {
      return 1.0;
    } else {
      return -1.0;
    }
  }
}
